
#include "stdafx.h"

#include <initguid.h>
#include "SDIB32GL.H"
#include "FpsTimer.h"
#include "util.h"

#define WINDOW_STYLE	WS_CAPTION | WS_SYSMENU | WS_MINIMIZEBOX | WS_POPUP
#define WINDOW_CLASS	"SDIB32GLSampleApp"

HINSTANCE	hInst;
HWND		hWnd;
char		szTitle[256];
CFpsTimer	FpsTimer;


/*----------------------------------------------------------------------------*
|	AvP[VGg[|Cg
*----------------------------------------------------------------------------*/
int APIENTRY WinMain(HINSTANCE hInstance,
                     HINSTANCE hPrevInstance,
                     LPSTR     lpCmdLine,
                     int       nCmdShow )
{
 	// TODO: ̈ʒuɃR[hLqĂB

	MyRegisterClass( hInstance );

	// CX^X
	if( !InitInstance( hInstance, nCmdShow ) ) return FALSE;

	// App
	if( !AppInitialize() ) return FALSE;

	// AppAChJn
	BEGIN_APPIDLE
	{
		// t[[gv
		FpsTimer.WaitFrame();

		// AppACh
		AppIdle();

	}END_APPIDLE;

	// AppN[Abv
	AppCleanUp();

	// AppI
	return msg.wParam;
}


//
//  ֐: MyRegisterClass()
//
//  pr: EBhE NX̓o^
//
//  Rg:
//
//    ̊֐т̎gp͂̃R[h Windows 95 Őɒǉꂽ
//    'RegisterClassEx' ֐ Win32 VXě݊ێꍇ
//    ̂ݕKvƂȂ܂BAvP[VAAvP[VɊ֘At
//    ꂽX[ ACR擾ł悤Å֐ĂяoƂ
//    dvłB
//
ATOM MyRegisterClass( HINSTANCE hInstance )
{
	WNDCLASSEX wcex;

	wcex.cbSize = sizeof(WNDCLASSEX); 

	wcex.style			= 0;
	wcex.lpfnWndProc	= (WNDPROC)WndProc;
	wcex.cbClsExtra		= 0;
	wcex.cbWndExtra		= 0;
	wcex.hInstance		= hInstance;
	wcex.hIcon			= ::LoadIcon( NULL,IDI_APPLICATION );
	wcex.hCursor		= ::LoadCursor( NULL, IDC_ARROW );
	wcex.hbrBackground	= (HBRUSH)GetStockObject( BLACK_BRUSH );
	wcex.lpszMenuName	= NULL;
	wcex.lpszClassName	= WINDOW_CLASS;
	wcex.hIconSm		= NULL;

	return RegisterClassEx( &wcex );
}


//
//   ֐: InitInstance(HANDLE, int)
//
//   pr: CX^X nh̕ۑƃC EBhE̍쐬
//
//   Rg:
//
//        ̊֐ł́ACX^X nhO[oϐɕۑAvO
//        C EBhE쐬\܂B
//
BOOL InitInstance( HINSTANCE hInstance, int nCmdShow )
{

	hInst = hInstance; // O[oϐɃCX^X nhۑ܂

	RECT rc = { 0, 0, CLIENT_WIDTH, CLIENT_HEIGHT };
	AdjustWindowRect( &rc, WINDOW_STYLE, FALSE );

	LONG nWidth  = rc.right-rc.left;
	LONG nHeight = rc.bottom-rc.top;

	LONG nX = (GetSystemMetrics(SM_CXSCREEN)-nWidth)/2;
	LONG nY = (GetSystemMetrics(SM_CYSCREEN)-nHeight)/2;

	char szBuf[256];
	GetModuleFileName( hInstance, szBuf, 256 );
	_splitpath( szBuf, NULL, NULL, szTitle, NULL );

	hWnd = CreateWindow(WINDOW_CLASS, szTitle, WINDOW_STYLE,
      nX, nY, nWidth, nHeight, NULL, NULL, hInstance, NULL);

	if( !hWnd ) 
	{
		return FALSE;
	}

	ShowWindow( hWnd, nCmdShow );
	UpdateWindow( hWnd );

	return TRUE;
}


//
//  ֐: WndProc(HWND, unsigned, WORD, LONG)
//
//  pr: C EBhẼbZ[W܂B
//
//  WM_COMMAND	- AvP[V j[̏
//  WM_PAINT	- C EBhE̕`
//  WM_DESTROY	- IbZ[W̒ʒmƃ^[
//
//
LRESULT CALLBACK WndProc(HWND hWnd, UINT message, WPARAM wParam, LPARAM lParam)
{
	switch( message ) 
	{
		case WM_PAINT: ON_PAINT; break;
		case WM_DESTROY: PostQuitMessage( 0 ); break;
		default:
			return DefWindowProc( hWnd, message, wParam, lParam );
   }
   return 0;
}


/*----------------------------------------------------------------------------*
|	eLXg[hݒ
*----------------------------------------------------------------------------*/
void SetTextMode( LPSDIB32GL lpBack )
{
	
	HDC hBackDC;
	lpBack->GetDC( &hBackDC );

	SetBkMode( hBackDC, TRANSPARENT );
	SetTextColor( hBackDC, RGB(255,0,0) );

}


/*----------------------------------------------------------------------------*
|	̕`
*----------------------------------------------------------------------------*/
void DrawInfo( LPSDIB32GL lpBack )
{

	char szBuf[256];

	sprintf( szBuf, "%6.2ffps UseMMX=%s Ver%4.2f", 
		FpsTimer.GetFPS(FPSTIMER_F_FPS,true), SDIB32GLIsMMX()?"YES":"NO", SDIB32GLGetVersion()/100.f );

	HDC hBackDC;
	lpBack->GetDC( &hBackDC );

	TextOut( hBackDC, 0, 0, szBuf, strlen(szBuf));
}