// Mono.cpp : AvP[Vp̃Gg |Cg̒`
//

#include "stdafx.h"

#include "SDIB32GL.H"
#include "util.h"

/*** C^[tFCX̏ ***/
LPSDIB32GLFACTORY	lpSDFactory = NULL;
LPSDIB32GL			lpBack		= NULL;
LPSDIB32GL			lpBg		= NULL;

const BSTR lpwszBgName[] = { 
	MEDIAPATH(OLESTR("OEh.jpg")), 
	MEDIAPATH(OLESTR("ejXR[g.jpg")),
	MEDIAPATH(OLESTR("t@~X.jpg")),
	MEDIAPATH(OLESTR("t@~XX.jpg")),
	MEDIAPATH(OLESTR(".jpg")),
	MEDIAPATH(OLESTR("wH.jpg")),
	MEDIAPATH(OLESTR(".jpg")),
	MEDIAPATH(OLESTR("̓.jpg")),
	MEDIAPATH(OLESTR("~.jpg")),
	MEDIAPATH(OLESTR("EnL.jpg")),
	MEDIAPATH(OLESTR("p.jpg")),
	MEDIAPATH(OLESTR("{.jpg")),
};

struct {
	long	s;
	long	dir_s;
}mono = { 0, 1 };


/*----------------------------------------------------------------------------*
|	App
*----------------------------------------------------------------------------*/
BOOL AppInitialize( void )
{
	HRESULT hr;

	try
	{
		// t@NgC^[tFCX擾
		hr = SDIB32GLFactoryCreate( 
			SDIB32GLCREATE_AUTO, (void**)&lpSDFactory, IID_ISDib32GLFactory );

		if( FAILED( hr ) )
		{
			throw exception("t@NgC^[tFCXs");
		}

		// NCAg̈TCỸobNobt@쐬
		hr = lpSDFactory->CreateBuffer(
			CLIENT_WIDTH, CLIENT_HEIGHT, 0, NULL, &lpBack );

		if( FAILED( hr ) )
		{
			throw exception("obNobt@̍쐬Ɏs");
		}

		RANDOMIZE;

		// BGǂݍ
		hr = lpSDFactory->CreateBufferFromFile(
			lpwszBgName[rand()%(sizeof(lpwszBgName)/sizeof(BSTR))], 0, NULL, 0, NULL, &lpBg );

		if( FAILED( hr ) )
		{
			throw exception("t@C̓ǂݍ݂Ɏs");
		}

	}


	// G[
	catch( exception& e )
	{
		
		MessageBox( hWnd, e.what(), szTitle, MB_OK | MB_ICONSTOP );

		// N[Abv
		AppCleanUp();

		return FALSE;
	}


	SetTextMode( lpBack );


	return TRUE;
}


/*----------------------------------------------------------------------------*
|	AppACh
*----------------------------------------------------------------------------*/
void AppIdle( void )
{

	lpBack->Blt( lpBg, 0, 0, NULL, NULL, NULL );

	// mN
	lpBack->Mono( 0, 0, CLIENT_WIDTH, CLIENT_HEIGHT, mono.s>255?255:mono.s );

	mono.s += mono.dir_s*2;

	if( mono.s < 0 )
	{
		mono.s = 0;
		mono.dir_s = -mono.dir_s;
	}else if( mono.s > 510 )
	{	
		mono.s = 510;
		mono.dir_s = -mono.dir_s;
	}

	// ̕`
	DrawInfo( lpBack );


	// ĕ`
	//*
	HDC hDC = GetDC( hWnd );
	lpBack->Draw( hDC );
	ReleaseDC( hWnd, hDC );
	/*/
	InvalidateRect( hWnd, NULL, FALSE );
	UpdateWindow( hWnd );
	//*/
}


/*----------------------------------------------------------------------------*
|	AppN[Abv
*----------------------------------------------------------------------------*/
void AppCleanUp( void )
{
	SAFE_RELEASE( lpBg );
	SAFE_RELEASE( lpBack );
	SAFE_RELEASE( lpSDFactory );
}


/*----------------------------------------------------------------------------*
|	WM_PAINT
*----------------------------------------------------------------------------*/
void OnPaint( HDC hdc )
{
	if( lpBack == NULL ) return;

	lpBack->Draw( hdc );
}