// Mosaic.cpp : AvP[Vp̃Gg |Cg̒`
//

#include "stdafx.h"

#include "SDIB32GL.H"
#include "util.h"
/*
LPSDIB32GL lpBack	= NULL;
LPSDIB32GL lpBg		= NULL;


int APIENTRY WinMain(HINSTANCE hInstance,
                     HINSTANCE hPrevInstance,
                     LPSTR     lpCmdLine,
                     int       nCmdShow )
{
 	// TODO: ̈ʒuɃR[hLqĂB

	MyRegisterClass( hInstance );

	if( !InitInstance( hInstance, nCmdShow ) )
	{
		return FALSE;
	}


	// MMX̔
	BOOL bMMX = SDIB32GL_IsMMX();

	const CLSID* pUse_CLSID;

	if( bMMX )
	{
		pUse_CLSID = &CLSID_SDib32GLPMMX;

	}else
	{
		pUse_CLSID = &CLSID_SDib32GLX86;
	}
	
	HRESULT hr;

	try
	{
		// obNobt@̍쐬
		hr = SDIB32GL_CreateBuffer( 
			CLIENT_WIDTH, CLIENT_HEIGHT, SDIB32GL_BLUE, NULL,
			*pUse_CLSID, IID_ISDib32GL, (LPVOID*)&lpBack );

		if( FAILED( hr ) )
		{
			throw exception("obNobt@̍쐬Ɏs");
		}

		// BGǂݍ
		hr = SDIB32GL_LoadFromFile(
			"../Media/BackGround.bmp", 0, NULL,
			*pUse_CLSID, IID_ISDib32GL, (LPVOID*)&lpBg );

		if( FAILED( hr ) )
		{
			throw exception("t@C̓ǂݍ݂Ɏs");
		}
	}

	// G[
	catch( exception& e )
	{
		
		MessageBox( hWnd, e.what(), szTitle, MB_OK | MB_ICONSTOP );

		if( lpBg ){		lpBg->Release(); lpBg = NULL; }
		if( lpBack ){	lpBack->Release(); lpBack = NULL; }

		return FALSE;
	}


	// bZ[W[v(C[`)
	MSG msg;

	for(;;)
	{
		if( PeekMessage( &msg, NULL, 0, 0, PM_REMOVE ) )
		{
			if( msg.message == WM_QUIT ) break;

			TranslateMessage( &msg );
			DispatchMessage( &msg );

		}else
		{

			// obNobt@NA
			//lpBack->Clear( SDIB32GL_RGB(150,220,255) );
			lpBack->Blt( lpBg, 0, 0, NULL, NULL, NULL );
			
			POINT mouse;
			GetCursorPos( &mouse );
			ScreenToClient( hWnd, &mouse );
			
			int d = (int)sqrt(
				((CLIENT_WIDTH_H-mouse.x)*(CLIENT_WIDTH_H-mouse.x)+
				(CLIENT_HEIGHT_H-mouse.y)*(CLIENT_HEIGHT_H-mouse.y)))/4;

			// UCN
			lpBack->Mosaic( 0, 0, CLIENT_WIDTH, CLIENT_HEIGHT, d, d );


			// FPSAMMXAo[W̕`
			DrawSDib32GLInfo( lpBack );

			// ĕ`
			InvalidateRect( hWnd, NULL, FALSE );
			UpdateWindow( hWnd );
		}
	}

	// BGobt@̉
	lpBg->Release();
	lpBg = NULL;

	// obNobt@̉
	lpBack->Release();
	lpBack = NULL;

	return msg.wParam;
}

*/



/*** C^[tFCX̏ ***/
LPSDIB32GLFACTORY	lpSDFactory = NULL;
LPSDIB32GL			lpBack		= NULL;
LPSDIB32GL			lpBg		= NULL;

const BSTR lpwszBgName[] = { 
	MEDIAPATH(OLESTR("OEh.jpg")), 
	MEDIAPATH(OLESTR("ejXR[g.jpg")),
	MEDIAPATH(OLESTR("t@~X.jpg")),
	MEDIAPATH(OLESTR("t@~XX.jpg")),
	MEDIAPATH(OLESTR(".jpg")),
	MEDIAPATH(OLESTR("wH.jpg")),
	MEDIAPATH(OLESTR(".jpg")),
	MEDIAPATH(OLESTR("̓.jpg")),
	MEDIAPATH(OLESTR("~.jpg")),
	MEDIAPATH(OLESTR("EnL.jpg")),
	MEDIAPATH(OLESTR("p.jpg")),
	MEDIAPATH(OLESTR("{.jpg")),
};

struct {
	long	b;
	long	dir_b;
}mosaic = { 0, 1 };


/*----------------------------------------------------------------------------*
|	App
*----------------------------------------------------------------------------*/
BOOL AppInitialize( void )
{
	HRESULT hr;

	try
	{
		// t@NgC^[tFCX擾
		hr = SDIB32GLFactoryCreate( 
			SDIB32GLCREATE_AUTO, (void**)&lpSDFactory, IID_ISDib32GLFactory );

		if( FAILED( hr ) )
		{
			throw exception("t@NgC^[tFCXs");
		}

		// NCAg̈TCỸobNobt@쐬
		hr = lpSDFactory->CreateBuffer(
			CLIENT_WIDTH, CLIENT_HEIGHT, 0, NULL, &lpBack );

		if( FAILED( hr ) )
		{
			throw exception("obNobt@̍쐬Ɏs");
		}

		RANDOMIZE;

		// BGǂݍ
		hr = lpSDFactory->CreateBufferFromFile(
			lpwszBgName[rand()%(sizeof(lpwszBgName)/sizeof(BSTR))], 0, NULL, 0, NULL, &lpBg );

		if( FAILED( hr ) )
		{
			throw exception("t@C̓ǂݍ݂Ɏs");
		}
	}


	// G[
	catch( exception& e )
	{
		
		MessageBox( hWnd, e.what(), szTitle, MB_OK | MB_ICONSTOP );

		// N[Abv
		AppCleanUp();

		return FALSE;
	}


	SetTextMode( lpBack );


	return TRUE;
}


/*----------------------------------------------------------------------------*
|	AppACh
*----------------------------------------------------------------------------*/
void AppIdle( void )
{

	lpBack->Blt( lpBg, 0, 0, NULL, NULL, NULL );
	
	// UCN
	lpBack->Mosaic( 0, 0, CLIENT_WIDTH, CLIENT_HEIGHT, mosaic.b, mosaic.b );

	mosaic.b += mosaic.dir_b;

	if( mosaic.b < 0 )
	{
		mosaic.b = 0;
		mosaic.dir_b = -mosaic.dir_b;
	}else if( mosaic.b > 100 )
	{
		mosaic.b = 100;
		mosaic.dir_b = -mosaic.dir_b;
	}

	// ̕`
	DrawInfo( lpBack );


	// ĕ`
	//*
	HDC hDC = GetDC( hWnd );
	lpBack->Draw( hDC );
	ReleaseDC( hWnd, hDC );
	/*/
	InvalidateRect( hWnd, NULL, FALSE );
	UpdateWindow( hWnd );
	//*/
}


/*----------------------------------------------------------------------------*
|	AppN[Abv
*----------------------------------------------------------------------------*/
void AppCleanUp( void )
{
	SAFE_RELEASE( lpBg );
	SAFE_RELEASE( lpBack );
	SAFE_RELEASE( lpSDFactory );
}


/*----------------------------------------------------------------------------*
|	WM_PAINT
*----------------------------------------------------------------------------*/
void OnPaint( HDC hdc )
{
	if( lpBack == NULL ) return;

	lpBack->Draw( hdc );
}