
/******************************************************************************
*
*	SDIB32GL(base) o[W݊֐
*
******************************************************************************/

#define SDIB32GLBASE_CAST( itf ) safe_cast(CSDib32GLBase*, itf)


// 
// SDIB32GL(base) ver.1
//

#undef SDIB32GLINTERFACE
#define SDIB32GLINTERFACE	ISDib32GL


STDMETHODIMP CSDib32GLBase::Blt( SDIB32GLINTERFACE* lpSrcSDIB32GL, long nDstX, long nDstY, LPSIZE lpDstSize, LPPOINT lpSrcPt, LPSIZE lpSrcSize )
{
	return InternalBlt( SDIB32GLBASE_CAST(lpSrcSDIB32GL), nDstX, nDstY, lpDstSize, lpSrcPt, lpSrcSize );
}


STDMETHODIMP CSDib32GLBase::ColorKeyBlt( SDIB32GLINTERFACE* lpSrcSDIB32GL, long nDstX, long nDstY, LPSIZE lpDstSize, LPPOINT lpSrcPt, LPSIZE lpSrcSize )
{
	return InternalColorKeyBlt( SDIB32GLBASE_CAST(lpSrcSDIB32GL), nDstX, nDstY, lpDstSize, lpSrcPt, lpSrcSize );
}


STDMETHODIMP CSDib32GLBase::RotateBlt( SDIB32GLINTERFACE* lpSrcSDIB32GL, long nDstX, long nDstY, LPSIZE lpDstSize, LPPOINT lpSrcPt, LPSIZE lpSrcSize, long nAngle, LPPOINT lpCenterPt )
{
	return InternalRotateBlt( SDIB32GLBASE_CAST(lpSrcSDIB32GL), nDstX, nDstY, lpDstSize, lpSrcPt, lpSrcSize, nAngle, lpCenterPt );
}


STDMETHODIMP CSDib32GLBase::RotateColorKeyBlt( SDIB32GLINTERFACE* lpSrcSDIB32GL, long nDstX, long nDstY, LPSIZE lpDstSize, LPPOINT lpSrcPt, LPSIZE lpSrcSize, long nAngle, LPPOINT lpCenterPt )
{
	return InternalRotateColorKeyBlt( SDIB32GLBASE_CAST(lpSrcSDIB32GL), nDstX, nDstY, lpDstSize, lpSrcPt, lpSrcSize, nAngle, lpCenterPt );
}


STDMETHODIMP CSDib32GLBase::RGBToAlphaBlt( SDIB32GLINTERFACE* lpSrcSDIB32GL, long nDstX, long nDstY, LPSIZE lpDstSize, LPPOINT lpSrcPt, LPSIZE lpSrcSize )
{
	return InternalRGBToAlphaBlt( SDIB32GLBASE_CAST(lpSrcSDIB32GL), nDstX, nDstY, lpDstSize, lpSrcPt, lpSrcSize );
}


STDMETHODIMP CSDib32GLBase::RToAlphaBlt( SDIB32GLINTERFACE* lpSrcSDIB32GL, long nDstX, long nDstY, LPSIZE lpDstSize, LPPOINT lpSrcPt, LPSIZE lpSrcSize )
{
	return InternalRToAlphaBlt( SDIB32GLBASE_CAST(lpSrcSDIB32GL), nDstX, nDstY, lpDstSize, lpSrcPt, lpSrcSize );
}


STDMETHODIMP CSDib32GLBase::GToAlphaBlt( SDIB32GLINTERFACE* lpSrcSDIB32GL, long nDstX, long nDstY, LPSIZE lpDstSize, LPPOINT lpSrcPt, LPSIZE lpSrcSize )
{
	return InternalGToAlphaBlt( SDIB32GLBASE_CAST(lpSrcSDIB32GL), nDstX, nDstY, lpDstSize, lpSrcPt, lpSrcSize );
}


STDMETHODIMP CSDib32GLBase::BToAlphaBlt( SDIB32GLINTERFACE* lpSrcSDIB32GL, long nDstX, long nDstY, LPSIZE lpDstSize, LPPOINT lpSrcPt, LPSIZE lpSrcSize )
{
	return InternalBToAlphaBlt( SDIB32GLBASE_CAST(lpSrcSDIB32GL), nDstX, nDstY, lpDstSize, lpSrcPt, lpSrcSize );
}


STDMETHODIMP CSDib32GLBase::AlphaToAlphaBlt( SDIB32GLINTERFACE* lpSrcSDIB32GL, long nDstX, long nDstY, LPSIZE lpDstSize, LPPOINT lpSrcPt, LPSIZE lpSrcSize )
{
	return InternalAlphaToAlphaBlt( SDIB32GLBASE_CAST(lpSrcSDIB32GL), nDstX, nDstY, lpDstSize, lpSrcPt, lpSrcSize );
}


STDMETHODIMP CSDib32GLBase::ColorKeyToColorBlt( SDIB32GLINTERFACE* lpSrcSDIB32GL, long nDstX, long nDstY, LPSIZE lpDstSize, LPPOINT lpSrcPt, LPSIZE lpSrcSize, SDIB32GLCOLOR Color )
{
	return InternalColorKeyToColorBlt( SDIB32GLBASE_CAST(lpSrcSDIB32GL), nDstX, nDstY, lpDstSize, lpSrcPt, lpSrcSize, Color );
}