#ifndef _INC_UTIL
#define _INC_UTIL


ATOM MyRegisterClass( HINSTANCE hInstance );
BOOL InitInstance( HINSTANCE hInstance, int nCmdShow );
LRESULT CALLBACK WndProc(HWND hWnd, UINT message, WPARAM wParam, LPARAM lParam);
void OnPaint( HDC hdc );
BOOL AppInitialize( void );
void AppIdle( void );
void AppCleanUp( void );
void SetTextMode( LPSDIB32GL lpBack );
void DrawInfo( LPSDIB32GL lpBack );

extern HINSTANCE	hInst;
extern HWND			hWnd;
extern char			szTitle[256];

#define CLIENT_WIDTH	640
#define CLIENT_HEIGHT	480
#define CLIENT_WIDTH_H		(CLIENT_WIDTH>>1)
#define CLIENT_HEIGHT_H		(CLIENT_HEIGHT>>1)
#define MEDIAPATH( file )	OLESTR("../../Media/")##file
#define SAFE_RELEASE(p)      { if(p) { (p)->Release(); (p)=NULL; } }
#define for	if(0){}else for
#define RANDOMIZE			srand(timeGetTime())

#define BEGIN_APPIDLE			\
	MSG	msg;	\
	for(;;) {	\
		if( ::PeekMessage( &msg, NULL, 0, 0, PM_REMOVE ) ) {	\
			if( msg.message == WM_QUIT ) break;	\
			::TranslateMessage( &msg );	\
			::DispatchMessage( &msg );	\
		} else {

#define END_APPIDLE	} }

#define BEGIN_PAINT	\
{	\
	PAINTSTRUCT ps;	\
	::BeginPaint( hWnd, &ps );

#define END_PAINT	\
	::EndPaint( hWnd, &ps ); }

#define ON_PAINT	\
BEGIN_PAINT	\
	::OnPaint( ps.hdc );	\
END_PAINT

#endif /* _INC_UTIL */