
#include "stdafx.h"

#include <initguid.h>
#include "SDIB32GL.H"
#include "fpstimer.h"
#include "DDUtil.h"
#include "resource.h"

#define WINDOW_STYLE	WS_CAPTION | WS_SYSMENU | WS_MINIMIZEBOX | WS_MAXIMIZEBOX | WS_POPUP | WS_VISIBLE
#define WINDOW_CLASS	"SDIB32GLSampleApp"

// DirectDrawG~[V[hŋN܂
// (DirectDraw̓G~̂قIȊł͈ԍœK)
#define DDRAW_MODE		(LPGUID)DDCREATE_EMULATIONONLY

// [̓VXegp܂	
#define DDRAW_MEMORYTYPE	(DDRAW_MODE!=(LPGUID)DDCREATE_EMULATIONONLY?DDSCAPS_VIDEOMEMORY:DDSCAPS_SYSTEMMEMORY)

// [U[`bZ[W
#define WM_DROPCAPTION		WM_USER


HINSTANCE	hInst;
HWND		hWnd;
char		szTitle[256];
CFpsTimer	FpsTimer;
BOOL		bWindowed = 1;
RECT		rcClient;
RECT		rcWindow;
RECT		rcSource;
LONG		nBorder;
LONG		nCaption;
LPDIRECTDRAW7 lpDD = NULL;
LPDIRECTDRAWSURFACE7 lpDDSPrimary = NULL;
LPDIRECTDRAWSURFACE7 lpDDSBack = NULL;
LPDIRECTDRAWCLIPPER lpDDClipper = NULL;


/*----------------------------------------------------------------------------*
|	AvP[VGg[|Cg
*----------------------------------------------------------------------------*/
int APIENTRY WinMain(HINSTANCE hInstance,
                     HINSTANCE hPrevInstance,
                     LPSTR     lpCmdLine,
                     int       nCmdShow )
{
 	// TODO: ̈ʒuɃR[hLqĂB

	MyRegisterClass( hInstance );

	// CX^X
	if( !InitInstance( hInstance, nCmdShow ) ) return FALSE;

	// App
	if( !AppInitialize() ) return FALSE;

	// AppAChJn
	BEGIN_APPIDLE
	{
		// t[[gv
		FpsTimer.WaitFrame();

		// AppACh
		AppIdle();

	}END_APPIDLE;

	// AppN[Abv
	AppCleanUp();

	// AppI
	return msg.wParam;
}


//
//  ֐: MyRegisterClass()
//
//  pr: EBhE NX̓o^
//
//  Rg:
//
//    ̊֐т̎gp͂̃R[h Windows 95 Őɒǉꂽ
//    'RegisterClassEx' ֐ Win32 VXě݊ێꍇ
//    ̂ݕKvƂȂ܂BAvP[VAAvP[VɊ֘At
//    ꂽX[ ACR擾ł悤Å֐ĂяoƂ
//    dvłB
//
ATOM MyRegisterClass( HINSTANCE hInstance )
{
	WNDCLASSEX wcex;

	wcex.cbSize = sizeof(WNDCLASSEX); 

	wcex.style			= CS_DBLCLKS;
	wcex.lpfnWndProc	= (WNDPROC)WndProc;
	wcex.cbClsExtra		= 0;
	wcex.cbWndExtra		= 0;
	wcex.hInstance		= hInstance;
	wcex.hIcon			= ::LoadIcon( NULL,IDI_APPLICATION );
	wcex.hCursor		= ::LoadCursor( NULL, IDC_ARROW );
	wcex.hbrBackground	= (HBRUSH)(COLOR_WINDOW+1);
	wcex.lpszMenuName	= "MENU";
	wcex.lpszClassName	= WINDOW_CLASS;
	wcex.hIconSm		= NULL;

	return RegisterClassEx( &wcex );
}


//
//   ֐: InitInstance(HANDLE, int)
//
//   pr: CX^X nh̕ۑƃC EBhE̍쐬
//
//   Rg:
//
//        ̊֐ł́ACX^X nhO[oϐɕۑAvO
//        C EBhE쐬\܂B
//
BOOL InitInstance( HINSTANCE hInstance, int nCmdShow )
{

	hInst = hInstance; // O[oϐɃCX^X nhۑ܂

	RECT rc = { 0, 0, CLIENT_WIDTH, CLIENT_HEIGHT};
	AdjustWindowRect( &rc, WINDOW_STYLE, TRUE );

	LONG nWidth  = rc.right-rc.left;
	LONG nHeight = rc.bottom-rc.top;

	LONG nX = (GetSystemMetrics(SM_CXSCREEN)-nWidth)/2;
	LONG nY = (GetSystemMetrics(SM_CYSCREEN)-nHeight)/2;

	char szBuf[256];
	GetModuleFileName( hInstance, szBuf, 256 );
	_splitpath( szBuf, NULL, NULL, szTitle, NULL );

	hWnd = CreateWindow(WINDOW_CLASS, szTitle, WINDOW_STYLE,
      nX, nY, nWidth, nHeight, NULL, NULL, hInstance, NULL);

	if( !hWnd ) 
	{
		return FALSE;
	}

	ShowWindow( hWnd, nCmdShow );
	UpdateWindow( hWnd );

	GetWindowRect( hWnd, &rcWindow );


	// LvV+j[Ƙg̃TCYvZ
	// tXN[̃NCAgEBhE킹邽
	RECT rcCap = { 0 };
	AdjustWindowRect( &rcCap, WS_CAPTION, TRUE );

	nBorder = (rcCap.right-rcCap.left)/2;
	nCaption = (rcCap.bottom-rcCap.top)-nBorder;

	return TRUE;
}


//
//  ֐: WndProc(HWND, unsigned, WORD, LONG)
//
//  pr: C EBhẼbZ[W܂B
//
//  WM_COMMAND	- AvP[V j[̏
//  WM_PAINT	- C EBhE̕`
//  WM_DESTROY	- IbZ[W̒ʒmƃ^[
//
//
LRESULT CALLBACK WndProc(HWND hWnd, UINT message, WPARAM wParam, LPARAM lParam)
{

	switch( message ) 
	{
	case WM_COMMAND:
	
		// j[bZ[W
		switch( LOWORD(wParam) )
		{
		case ID_MENUEXIT:	// I

			SendMessage( hWnd, WM_CLOSE, NULL, NULL );
			break;
		case ID_MENUWIN:	// EBhE[h

			if( !bWindowed )
				SendMessage( hWnd, WM_KEYDOWN, VK_F4, NULL );
			break;
		case ID_MENUFULL:	// tXN[[h

			if( bWindowed )
				SendMessage( hWnd, WM_KEYDOWN, VK_F4, NULL );
			break;
		}
		break;
	case WM_SYSKEYDOWN:

		if( wParam == VK_RETURN )
		{
			// ALT+ENTERɂȂ鉹Ȃ߃bZ[WL[菜
			MSG msg;
			PeekMessage( &msg, NULL, 0, 0, PM_REMOVE );

			SendMessage( hWnd, WM_KEYDOWN, VK_F4, NULL );
		}
		break;
	case WM_KEYDOWN:

		switch( wParam )
		{
		case VK_ESCAPE:	// I

			SendMessage( hWnd, WM_CLOSE, NULL, NULL );
			break;
		case VK_F4:		// fBXvCύX

			// DirectDrawIuWFNgӊO
			SAFE_RELEASE( lpDDClipper );
			SAFE_RELEASE( lpDDSBack );
			SAFE_RELEASE( lpDDSPrimary );

			// ɃtXN[ɂȂꍇ̓EBhË(x, yƃTCY)ۑ
			if( bWindowed ) GetWindowRect( hWnd, &rcWindow );

			// EBhE[htO𔽓]
			bWindowed ^= 1;

			try
			{
				// DirectDraw̏
				InitDirectDraw( hWnd );

				// j[`FbN̐؂ւ
				if( bWindowed )
				{
					CheckMenuItem( GetMenu(hWnd), ID_MENUWIN, MF_BYCOMMAND|MFS_CHECKED );
					CheckMenuItem( GetMenu(hWnd), ID_MENUFULL, MF_BYCOMMAND|MFS_UNCHECKED );
				}else
				{
					CheckMenuItem( GetMenu(hWnd), ID_MENUWIN, MF_BYCOMMAND|MFS_UNCHECKED );
					CheckMenuItem( GetMenu(hWnd), ID_MENUFULL, MF_BYCOMMAND|MFS_CHECKED );
				}
			}

			// G[
			catch( exception& e )
			{
				ShowWindow( hWnd, SW_HIDE );
				MessageBox( hWnd, e.what(), szTitle, MB_OK | MB_ICONSTOP );
				SendMessage( hWnd, WM_CLOSE, NULL, NULL );
			}
			break;
		}
		break;
	case WM_PAINT:
		
		ValidateRect( hWnd, NULL );
		// TODO: ̈ʒuɕ`p̃R[hǉĂ...
		
		OnPaint();
		break;
	case WM_SYSCOMMAND:

		switch( wParam )
		{
		case SC_MAXIMIZE:

			// ő剻bZ[WɑăfBXvC`FW
			SendMessage( hWnd, WM_KEYDOWN, VK_F4, (LPARAM)0 );
			return 0;
		case SC_KEYMENU:

			// tXN[LvVhbv
			if( !bWindowed )
				SendMessage( hWnd, WM_DROPCAPTION, MAKEWPARAM(TRUE,nCaption-nBorder), MAKELPARAM(-nBorder,-nBorder));
			break;
		case SC_MOVE:

			// tXN[̃EBhEړ
			if( !bWindowed ) return 0;
			break;
		}
		
		return DefWindowProc( hWnd, message, wParam, lParam );
	case WM_NCLBUTTONDBLCLK:

		// ^Cgo[_uNbN(ő剻)ŃfBXvC`FW
		if( wParam == HTCAPTION )
		{
			SendMessage( hWnd, WM_KEYDOWN, VK_F4, (LPARAM)0 );
			break;
		}

		return DefWindowProc( hWnd, message, wParam, lParam );
	case WM_NCLBUTTONDOWN:

		// tXN[̃EBhEړ
		if( !bWindowed && wParam == HTCAPTION ) break;
		
		return DefWindowProc( hWnd, message, wParam, lParam );
	case WM_MOUSEMOVE:

		// tXN[}EX|C^ɗLvVhbv
		if( !bWindowed )
		{
			if( 2 > HIWORD( lParam ) )
			{
				// ̎A^Cgo[(j[)Oŕ`悵ȂƂȂ̂TRUEn
				SendMessage( hWnd, WM_DROPCAPTION, MAKEWPARAM(TRUE,nCaption-nBorder), MAKELPARAM(-nBorder,-nBorder));
			}
		}
		break;
	case WM_NCHITTEST:
		
		wParam = DefWindowProc( hWnd, message, wParam, lParam );

		// NCAg̈Ƀ}EX|C^ꍇLvVʒuɈړ
		if( !bWindowed && wParam == HTCLIENT )
		{
			SendMessage( hWnd, WM_DROPCAPTION, MAKEWPARAM(FALSE,0), MAKELPARAM(-nBorder,-nCaption));
		}
		return wParam;
	case WM_SIZE:

		if( !bWindowed && wParam == SIZE_RESTORED )
		{
			// tXN[EBhEꂽLvVʒuɈړ
			PostMessage( hWnd, WM_DROPCAPTION, MAKEWPARAM(FALSE,0), MAKELPARAM(-nBorder,-nCaption));
		}
		break;
	case WM_DROPCAPTION:
			
		// ]̈̐ݒ
		SetRect( &rcSource, 0, (short)HIWORD(wParam), CLIENT_WIDTH, CLIENT_HEIGHT );

		// A|bvAbvEBhÊ悤xd|
		// ړ͎OŃLvVj[ĕ`悷
		MoveWindow( hWnd,  (short)LOWORD(lParam), (short)HIWORD(lParam),
			rcWindow.right-rcWindow.left, rcWindow.bottom-rcWindow.top, FALSE );
		
		if( LOWORD(wParam) )
		{
			// LvVj[̍ĕ`
			DrawMenuBar(hWnd);
		}

		break;
	case WM_MOVE:

		// ]̈擾
		GetClientRect( hWnd, &rcClient);
		ClientToScreen( hWnd, ( LPPOINT )&rcClient );
		ClientToScreen( hWnd,( LPPOINT )&rcClient+1);
		break;
	case WM_DESTROY:

		PostQuitMessage( 0 );
		break;
	default:
		return DefWindowProc( hWnd, message, wParam, lParam );
   }
   return 0;
}



/*----------------------------------------------------------------------------*
|	DirectDraw
*----------------------------------------------------------------------------*/
void InitDirectDraw( HWND hWnd )
{

	// DirectDraw7IuWFNg쐬
	if( lpDD == NULL )
	{
		DirectDrawCreateEx( DDRAW_MODE, (LPVOID*)&lpDD, IID_IDirectDraw7, NULL );

		if( lpDD == NULL )

			throw exception("DirectDraw7IuWFNg쐬s"); 
	}

	HRESULT hr;

	SetRect( &rcSource, 0, 0, CLIENT_WIDTH, CLIENT_HEIGHT );

	if( bWindowed )
	{
		// fBXvC[h
		lpDD->RestoreDisplayMode();

		// EBhEX^CύX
		SetWindowLong( hWnd, GWL_STYLE, WINDOW_STYLE );

		// EBh|WV
		SetWindowPos( hWnd, NULL, rcWindow.left, rcWindow.top, 
			rcWindow.right-rcWindow.left, rcWindow.bottom-rcWindow.top,
					 SWP_NOZORDER | SWP_NOACTIVATE | SWP_DRAWFRAME );

		// xݒ
		hr = lpDD->SetCooperativeLevel( hWnd, DDSCL_NORMAL );

		if( FAILED( hr ) )
		{
			throw exception("DirectDraw7x̐ݒ莸s");
		}


		DDSURFACEDESC2 ddsd = { 0 };

		// vC}[T[tFCX쐬
		ddsd.dwSize  = sizeof( DDSURFACEDESC2 );
		ddsd.dwFlags = DDSD_CAPS;
		ddsd.ddsCaps.dwCaps = DDSCAPS_PRIMARYSURFACE | DDRAW_MEMORYTYPE;

		hr = lpDD->CreateSurface( &ddsd, &lpDDSPrimary, NULL );

		if( FAILED( hr ) )
		{
			throw exception("DirectDraw7vC}[T[tFCX쐬s");
		}


		// ZJ_(obN)T[tFCX쐬
		//
		// (2004/3/29 EBhE[ĥ݃ZJ_T[tFCXgp悤ɏC)
		// ̃EBhEƂ̏dȂ肪z肳EBhE[h̎
		// Nbp[IuWFNgƃZJ_T[tFCX쐬Ȃ΂Ȃ
		// ڃvC}DC擾ĕ`悷ƃNbsO܂B
		ddsd.ddsCaps.dwCaps = DDSCAPS_OFFSCREENPLAIN | DDRAW_MEMORYTYPE;
		ddsd.dwFlags = DDSD_CAPS | DDSD_WIDTH | DDSD_HEIGHT;
		ddsd.dwWidth = CLIENT_WIDTH;
		ddsd.dwHeight = CLIENT_HEIGHT;
		
		hr = lpDD->CreateSurface( &ddsd, &lpDDSBack, NULL );

		if( FAILED( hr ) )
		{
			throw exception("DirectDraw7ZJ_[T[tFCX쐬s");
		}

		// Nbp[̍쐬
		hr = lpDD->CreateClipper( NULL, &lpDDClipper, NULL );

		if( FAILED( hr ) )
		{
			throw exception( "DirectDraw7Nbp[쐬s" );
		}
		
		// Nbp[ɃEBhEnh֘AÂ
		hr = lpDDClipper->SetHWnd( NULL, hWnd );

		if( FAILED( hr ) )
		{
			throw exception( "DirectDraw7Nbp[EBhEnhݒ莸s" );
		}

		// Nbp[̐ݒ
		hr = lpDDSPrimary->SetClipper( lpDDClipper );

		if( FAILED( hr ) )
		{
			throw exception( "DirectDraw7Nbp[ݒ莸s");
		}

	}else
	{
		// EBhEX^CύX
		// WS_POPUPX^Cł͂ȂAEBhẼX^CƓɂ̂ŕύX܂
		// SetWindowLong( hWnd, GWL_STYLE, WINDOW_STYLE );
		

		// xݒ
		hr = lpDD->SetCooperativeLevel( hWnd, DDSCL_EXCLUSIVE | DDSCL_FULLSCREEN | DDSCL_ALLOWREBOOT );

		if( FAILED( hr ) )
		{
			throw exception("DirectDraw7x̐ݒ莸s");
		}

		// fBXvC[hݒ
		hr = lpDD->SetDisplayMode( CLIENT_WIDTH, CLIENT_HEIGHT, 16, NULL, NULL );

		if( FAILED( hr ) )
		{
			throw exception("DirectDraw7fBXvC[hݒ莸s");
		}


		DDSURFACEDESC2 ddsd = { 0 };

		// vC}[T[tFCX쐬
		ddsd.dwSize  = sizeof( DDSURFACEDESC2 );

		// tXN[̓ZJ_(obN)T[tFCX̍쐬͂Ȃ̂
		// vC}Ɉȉ̐ݒ͍s܂
/*
		ddsd.dwFlags = DDSD_CAPS | DDSD_BACKBUFFERCOUNT;
		ddsd.dwBackBufferCount = 1;
		ddsd.ddsCaps.dwCaps = DDSCAPS_PRIMARYSURFACE | DDSCAPS_FLIP | 
								DDSCAPS_COMPLEX | DDRAW_MEMORYTYPE;
/*/
		ddsd.dwFlags = DDSD_CAPS;
		ddsd.ddsCaps.dwCaps = DDSCAPS_PRIMARYSURFACE | DDRAW_MEMORYTYPE;
//*/
		hr = lpDD->CreateSurface( &ddsd, &lpDDSPrimary, NULL );

		if( FAILED( hr ) )
		{
			throw exception("DirectDraw7vC}[T[tFCX쐬s");
		}

		// ZJ_T[tFCX̍쐬͍s܂
/*
		// ZJ_T[tFCX쐬
		ddsd.ddsCaps.dwCaps = DDSCAPS_BACKBUFFER | DDRAW_MEMORYTYPE;

		lpDDSPrimary->GetAttachedSurface( &ddsd.ddsCaps, &lpDDSBack );

		if( FAILED( hr ) )
		{
			throw exception("DirectDraw7ZJ_[T[tFCX쐬s");
		}
//*/

	}

}


/*----------------------------------------------------------------------------*
|	DirectDrawI
*----------------------------------------------------------------------------*/
void UnInitDirectDraw( void )
{
	// fBXvC[h
	if( lpDD && !bWindowed ){ lpDD->RestoreDisplayMode(); }

	SAFE_RELEASE( lpDDClipper );
	SAFE_RELEASE( lpDDSBack );
	SAFE_RELEASE( lpDDSPrimary );
	SAFE_RELEASE( lpDD );
}


/*----------------------------------------------------------------------------*
|	eLXg[hݒ
*----------------------------------------------------------------------------*/
void SetTextMode( LPSDIB32GL lpBack )
{
	
	HDC hBackDC;
	lpBack->GetDC( &hBackDC );

	SetBkMode( hBackDC, TRANSPARENT );
	SetTextColor( hBackDC, RGB(255,0,0) );

}


/*----------------------------------------------------------------------------*
|	̕`
*----------------------------------------------------------------------------*/
void DrawInfo( LPSDIB32GL lpBack )
{

	char szBuf[256];

	sprintf( szBuf, "%6.2ffps UseMMX=%s Ver%4.2f Screen Change[ Alt+Enter or F4 ]", 
		FpsTimer.GetFPS(FPSTIMER_F_FPS,true), SDIB32GLIsMMX()?"YES":"NO", SDIB32GLGetVersion()/100.f );

	HDC hBackDC;
	lpBack->GetDC( &hBackDC );

	TextOut( hBackDC, 0, 0, szBuf, strlen(szBuf));
}