
/******************************************************************************
*
*	SDIB32GL(PMMX) o[W݊֐
*
******************************************************************************/

#define SDIB32GLPMMX_CAST( itf ) safe_cast(CSDib32GLPMMX*, itf)


// 
// SDIB32GL(PMMX) ver.1
//

#undef SDIB32GLINTERFACE
#define SDIB32GLINTERFACE	ISDib32GL


STDMETHODIMP CSDib32GLPMMX::AlphaBlendBlt( SDIB32GLINTERFACE* lpSrcSDIB32GL, long nDstX, long nDstY, LPSIZE lpDstSize, LPPOINT lpSrcPt, LPSIZE lpSrcSize, BYTE Alpha )
{
	return InternalAlphaBlendBlt( SDIB32GLPMMX_CAST(lpSrcSDIB32GL), nDstX, nDstY, lpDstSize, lpSrcPt, lpSrcSize, Alpha );
}


STDMETHODIMP CSDib32GLPMMX::ColorKeyAlphaBlendBlt( SDIB32GLINTERFACE* lpSrcSDIB32GL, long nDstX, long nDstY, LPSIZE lpDstSize, LPPOINT lpSrcPt, LPSIZE lpSrcSize, BYTE Alpha )
{
	return InternalColorKeyAlphaBlendBlt( SDIB32GLPMMX_CAST(lpSrcSDIB32GL), nDstX, nDstY, lpDstSize, lpSrcPt, lpSrcSize, Alpha );
}


STDMETHODIMP CSDib32GLPMMX::AddBlendBlt( SDIB32GLINTERFACE* lpSrcSDIB32GL, long nDstX, long nDstY, LPSIZE lpDstSize, LPPOINT lpSrcPt, LPSIZE lpSrcSize )
{
	return InternalAddBlendBlt( SDIB32GLPMMX_CAST(lpSrcSDIB32GL), nDstX, nDstY, lpDstSize, lpSrcPt, lpSrcSize );
}


STDMETHODIMP CSDib32GLPMMX::AddAlphaBlendBlt( SDIB32GLINTERFACE* lpSrcSDIB32GL, long nDstX, long nDstY, LPSIZE lpDstSize, LPPOINT lpSrcPt, LPSIZE lpSrcSize, BYTE Alpha )
{
	return InternalAddAlphaBlendBlt( SDIB32GLPMMX_CAST(lpSrcSDIB32GL), nDstX, nDstY, lpDstSize, lpSrcPt, lpSrcSize, Alpha );
}


STDMETHODIMP CSDib32GLPMMX::SubBlendBlt( SDIB32GLINTERFACE* lpSrcSDIB32GL, long nDstX, long nDstY, LPSIZE lpDstSize, LPPOINT lpSrcPt, LPSIZE lpSrcSize )
{
	return InternalSubBlendBlt( SDIB32GLPMMX_CAST(lpSrcSDIB32GL), nDstX, nDstY, lpDstSize, lpSrcPt, lpSrcSize );
}


STDMETHODIMP CSDib32GLPMMX::SubAlphaBlendBlt( SDIB32GLINTERFACE* lpSrcSDIB32GL, long nDstX, long nDstY, LPSIZE lpDstSize, LPPOINT lpSrcPt, LPSIZE lpSrcSize, BYTE Alpha )
{
	return InternalSubAlphaBlendBlt( SDIB32GLPMMX_CAST(lpSrcSDIB32GL), nDstX, nDstY, lpDstSize, lpSrcPt, lpSrcSize, Alpha );
}


STDMETHODIMP CSDib32GLPMMX::AlphaChannelBlt( SDIB32GLINTERFACE* lpSrcSDIB32GL, long nDstX, long nDstY, LPSIZE lpDstSize, LPPOINT lpSrcPt, LPSIZE lpSrcSize )
{
	return InternalAlphaChannelBlt( SDIB32GLPMMX_CAST(lpSrcSDIB32GL), nDstX, nDstY, lpDstSize, lpSrcPt, lpSrcSize );
}


STDMETHODIMP CSDib32GLPMMX::AlphaChannelAlphaBlendBlt( SDIB32GLINTERFACE* lpSrcSDIB32GL, long nDstX, long nDstY, LPSIZE lpDstSize, LPPOINT lpSrcPt, LPSIZE lpSrcSize, BYTE Alpha )
{
	return InternalAlphaChannelAlphaBlendBlt( SDIB32GLPMMX_CAST(lpSrcSDIB32GL), nDstX, nDstY, lpDstSize, lpSrcPt, lpSrcSize, Alpha );
}


STDMETHODIMP CSDib32GLPMMX::AlphaChannelMaskBlt( SDIB32GLINTERFACE* lpSrcSDIB32GL, long nDstX, long nDstY, LPSIZE lpDstSize, LPPOINT lpSrcPt, LPSIZE lpSrcSize )
{
	return InternalAlphaChannelMaskBlt( SDIB32GLPMMX_CAST(lpSrcSDIB32GL), nDstX, nDstY, lpDstSize, lpSrcPt, lpSrcSize );
}


STDMETHODIMP CSDib32GLPMMX::AlphaChannelMaskAlphaBlendBlt( SDIB32GLINTERFACE* lpSrcSDIB32GL, long nDstX, long nDstY, LPSIZE lpDstSize, LPPOINT lpSrcPt, LPSIZE lpSrcSize, BYTE Alpha )
{
	return InternalAlphaChannelMaskAlphaBlendBlt( SDIB32GLPMMX_CAST(lpSrcSDIB32GL), nDstX, nDstY, lpDstSize, lpSrcPt, lpSrcSize, Alpha );
}


STDMETHODIMP CSDib32GLPMMX::RotateAlphaBlendBlt( SDIB32GLINTERFACE* lpSrcSDIB32GL, long nDstX, long nDstY, LPSIZE lpDstSize, LPPOINT lpSrcPt, LPSIZE lpSrcSize, BYTE Alpha, long nAngle, LPPOINT lpCenterPt )
{
	return InternalRotateAlphaBlendBlt( SDIB32GLPMMX_CAST(lpSrcSDIB32GL), nDstX, nDstY, lpDstSize, lpSrcPt, lpSrcSize, Alpha, nAngle, lpCenterPt );
}


STDMETHODIMP CSDib32GLPMMX::RotateColorKeyAlphaBlendBlt( SDIB32GLINTERFACE* lpSrcSDIB32GL, long nDstX, long nDstY, LPSIZE lpDstSize, LPPOINT lpSrcPt, LPSIZE lpSrcSize, BYTE Alpha, long nAngle, LPPOINT lpCenterPt )
{
	return InternalRotateColorKeyAlphaBlendBlt( SDIB32GLPMMX_CAST(lpSrcSDIB32GL), nDstX, nDstY, lpDstSize, lpSrcPt, lpSrcSize, Alpha, nAngle, lpCenterPt );
}


STDMETHODIMP CSDib32GLPMMX::RotateAddBlendBlt( SDIB32GLINTERFACE* lpSrcSDIB32GL, long nDstX, long nDstY, LPSIZE lpDstSize, LPPOINT lpSrcPt, LPSIZE lpSrcSize, long nAngle, LPPOINT lpCenterPt )
{
	return InternalRotateAddBlendBlt( SDIB32GLPMMX_CAST(lpSrcSDIB32GL), nDstX, nDstY, lpDstSize, lpSrcPt, lpSrcSize, nAngle, lpCenterPt );
}


STDMETHODIMP CSDib32GLPMMX::RotateAddAlphaBlendBlt( SDIB32GLINTERFACE* lpSrcSDIB32GL, long nDstX, long nDstY, LPSIZE lpDstSize, LPPOINT lpSrcPt, LPSIZE lpSrcSize, BYTE Alpha, long nAngle, LPPOINT lpCenterPt )
{
	return InternalRotateAddAlphaBlendBlt( SDIB32GLPMMX_CAST(lpSrcSDIB32GL), nDstX, nDstY, lpDstSize, lpSrcPt, lpSrcSize, Alpha, nAngle, lpCenterPt );
}


STDMETHODIMP CSDib32GLPMMX::RotateSubBlendBlt( SDIB32GLINTERFACE* lpSrcSDIB32GL, long nDstX, long nDstY, LPSIZE lpDstSize, LPPOINT lpSrcPt, LPSIZE lpSrcSize, long nAngle, LPPOINT lpCenterPt )
{
	return InternalRotateSubBlendBlt( SDIB32GLPMMX_CAST(lpSrcSDIB32GL), nDstX, nDstY, lpDstSize, lpSrcPt, lpSrcSize, nAngle, lpCenterPt );
}


STDMETHODIMP CSDib32GLPMMX::RotateSubAlphaBlendBlt( SDIB32GLINTERFACE* lpSrcSDIB32GL, long nDstX, long nDstY, LPSIZE lpDstSize, LPPOINT lpSrcPt, LPSIZE lpSrcSize, BYTE Alpha, long nAngle, LPPOINT lpCenterPt )
{
	return InternalRotateSubAlphaBlendBlt( SDIB32GLPMMX_CAST(lpSrcSDIB32GL), nDstX, nDstY, lpDstSize, lpSrcPt, lpSrcSize, Alpha, nAngle, lpCenterPt );
}


STDMETHODIMP CSDib32GLPMMX::RotateAlphaChannelBlt( SDIB32GLINTERFACE* lpSrcSDIB32GL, long nDstX, long nDstY, LPSIZE lpDstSize, LPPOINT lpSrcPt, LPSIZE lpSrcSize, long nAngle, LPPOINT lpCenterPt )
{
	return InternalRotateAlphaChannelBlt( SDIB32GLPMMX_CAST(lpSrcSDIB32GL), nDstX, nDstY, lpDstSize, lpSrcPt, lpSrcSize, nAngle, lpCenterPt );
}


STDMETHODIMP CSDib32GLPMMX::RotateAlphaChannelAlphaBlendBlt( SDIB32GLINTERFACE* lpSrcSDIB32GL, long nDstX, long nDstY, LPSIZE lpDstSize, LPPOINT lpSrcPt, LPSIZE lpSrcSize, BYTE Alpha, long nAngle, LPPOINT lpCenterPt )
{
	return InternalRotateAlphaChannelAlphaBlendBlt( SDIB32GLPMMX_CAST(lpSrcSDIB32GL), nDstX, nDstY, lpDstSize, lpSrcPt, lpSrcSize, Alpha, nAngle, lpCenterPt );
}


STDMETHODIMP CSDib32GLPMMX::RotateAlphaChannelMaskBlt( SDIB32GLINTERFACE* lpSrcSDIB32GL, long nDstX, long nDstY, LPSIZE lpDstSize, LPPOINT lpSrcPt, LPSIZE lpSrcSize, long nAngle, LPPOINT lpCenterPt )
{
	return InternalRotateAlphaChannelMaskBlt( SDIB32GLPMMX_CAST(lpSrcSDIB32GL), nDstX, nDstY, lpDstSize, lpSrcPt, lpSrcSize, nAngle, lpCenterPt );
}


STDMETHODIMP CSDib32GLPMMX::RotateAlphaChannelMaskAlphaBlendBlt( SDIB32GLINTERFACE* lpSrcSDIB32GL, long nDstX, long nDstY, LPSIZE lpDstSize, LPPOINT lpSrcPt, LPSIZE lpSrcSize, BYTE Alpha, long nAngle, LPPOINT lpCenterPt )
{
	return InternalRotateAlphaChannelMaskAlphaBlendBlt( SDIB32GLPMMX_CAST(lpSrcSDIB32GL), nDstX, nDstY, lpDstSize, lpSrcPt, lpSrcSize, Alpha, nAngle, lpCenterPt );
}


STDMETHODIMP CSDib32GLPMMX::UniversalTransBlt( SDIB32GLINTERFACE* lpSrcSDIB32GL, long nDstX, long nDstY, LPSIZE lpDstSize, LPPOINT lpSrcPt, LPSIZE lpSrcSize, SDIB32GLINTERFACE* lpRuleSDIB32GL, WORD wPhase, BYTE Vague, DWORD dwRuleFlags )
{
	return InternalUniversalTransBlt( SDIB32GLPMMX_CAST(lpSrcSDIB32GL), nDstX, nDstY, lpDstSize, lpSrcPt, lpSrcSize, SDIB32GLPMMX_CAST(lpRuleSDIB32GL), wPhase, Vague, dwRuleFlags );
}


STDMETHODIMP CSDib32GLPMMX::UniversalTransColorKeyBlt( SDIB32GLINTERFACE* lpSrcSDIB32GL, long nDstX, long nDstY, LPSIZE lpDstSize, LPPOINT lpSrcPt, LPSIZE lpSrcSize, SDIB32GLINTERFACE* lpRuleSDIB32GL, WORD wPhase, BYTE Vague, DWORD dwRuleFlags )
{
	return InternalUniversalTransColorKeyBlt( SDIB32GLPMMX_CAST(lpSrcSDIB32GL), nDstX, nDstY, lpDstSize, lpSrcPt, lpSrcSize, SDIB32GLPMMX_CAST(lpRuleSDIB32GL), wPhase, Vague, dwRuleFlags );
}


STDMETHODIMP CSDib32GLPMMX::UniversalTransAlphaChannelBlt( SDIB32GLINTERFACE* lpSrcSDIB32GL, long nDstX, long nDstY, LPSIZE lpDstSize, LPPOINT lpSrcPt, LPSIZE lpSrcSize, SDIB32GLINTERFACE* lpRuleSDIB32GL, WORD wPhase, BYTE Vague, DWORD dwRuleFlags )
{
	return InternalUniversalTransAlphaChannelBlt( SDIB32GLPMMX_CAST(lpSrcSDIB32GL), nDstX, nDstY, lpDstSize, lpSrcPt, lpSrcSize, SDIB32GLPMMX_CAST(lpRuleSDIB32GL), wPhase, Vague, dwRuleFlags );
}