#ifndef _INC_SDIB32GLBASE
#define _INC_SDIB32GLBASE


/*----------------------------------------------------------------------------*
|	SDIB32GLBase UTILITY MACROS
*----------------------------------------------------------------------------*/
// 255iK̒l256iKɕϊ}N
#define CONVERT_255To256( a ) (a+(a>>7))			// 256/255̎̔{Ō߂̍XȂœK
													// ʃrbg𗘗pĕϊ
						// (((a+1)>>8)+a)			// 255̎256ɂ
						// ((a*0x10101+0x8000)>>16) // 256/255̔{Ō߂(œK)
						// (((a<<8)+127)/255)		// 256/255̔{Ō߂

#define DEST_ALPHA( a )		(256-a)

// [vJE^ϊp
#define __DEC_WIDTH			0x10000
#define __DEC_HEIGHT		0xffff0001
#define CONVERT_WIDTH( w )	((w-1)<<16)
#define CONVERT_HEIGHT( h )	(h-1)

// `l}XN
#define __Axxx_MASK			0xff000000

// RGB }XN
#define __xRGB_MASK			0x00ffffff


/*----------------------------------------------------------------------------*
|	SDIB32GLBase Structures
*----------------------------------------------------------------------------*/
// DIB`Xe[^X
typedef struct
{
	LONG		nDstX;			// ]XW
	LONG		nDstY;			// ]YW
	LONG		nSrcX;			// ]XW
	LONG		nSrcY;			// ]YW
	LONG		nWidth;			// ]镝
	LONG		nHeight;		// ]鍂
	LONG		nSrcAddDirX;	// ]XZ
	LONG		nSrcAddDirY;	// ]YZ
	LONG		nDstAddY;		// ]̎̃CɃANZ邽߂̃oCg

	bool		bZoom;			// gktO
	LONG		nEx;			// 덷x
	LONG		nEy;			// 덷y
	LONG		nERx;			// 덷Clx
	LONG		nERy;			// 덷Cly
	LONG		nMx;			// Xx(gk)
	LONG		nMy;			// Xy(gk)
	LONG		nSrcAddRx;		// k̓]XZ␳l
	LONG		nSrcAddRy;		// k̓]YZ␳l
	LPVOID		pLineHead;		// C̐擪AhX

}SDIB32GLSTATUS;

typedef long SDIB32GLFIXED;

// DIB]`Xe[^X
typedef struct
{
	LONG		nDstX;			// ]XW
	LONG		nDstY;			// ]YW
	LONG		nAngle;			// ]px
	LONG		nSrcX;			// ]XW
	LONG		nSrcY;			// ]YW
	union{
		SDIB32GLFIXED	fxSrcScanX;		// ]̑JnXW(Œ菬)
		SDIB32GLFIXED	fxSrcScanX_L;
	};
	union{
		SDIB32GLFIXED	fxSrcScanY;		// ]̑JnYW(Œ菬)
		SDIB32GLFIXED	fxSrcScanY_L;
	};
	LONG		nWidth;			// ]镝
	LONG		nHeight;		// ]鍂
	LONG		nDstAddY;		// ]̎̃CɃANZ邽߂̃oCg
	
	union{
		SDIB32GLFIXED	fxSrcAddXx;		// ]XxZl(Œ菬)
		SDIB32GLFIXED	fxSrcAddXx_L;
	};
	union{
		SDIB32GLFIXED	fxSrcAddXy;		// ]XyZl(Œ菬)
		SDIB32GLFIXED	fxSrcAddXy_L;
	};
	union{
		SDIB32GLFIXED	fxSrcAddYx;		// ]YxZl(Œ菬)
		SDIB32GLFIXED	fxSrcAddYx_L;
	};
	union{
		SDIB32GLFIXED	fxSrcAddYy;		// ]YyZl(Œ菬)
		SDIB32GLFIXED	fxSrcAddYy_L;
	};

	union{
		SDIB32GLFIXED	fxSrcLeft;
		LONG			nSrcLeft;
	};
	union{
		SDIB32GLFIXED	fxSrcTop;
		LONG			nSrcTop;
	};
	union{
		SDIB32GLFIXED	fxSrcRight;
		LONG			nSrcRight;
	};
	union{
		SDIB32GLFIXED	fxSrcBottom;
		LONG			nSrcBottom;
	};

	bool				b64bit;				// Œ菭64rbgtO
	SDIB32GLFIXED		fxSrcScanX_H;		// ]̑JnXW
	SDIB32GLFIXED		fxSrcScanY_H;		// ]̑JnYW
	SDIB32GLFIXED		fxSrcAddXx_H;		// ]XxZl
	SDIB32GLFIXED		fxSrcAddXy_H;		// ]XyZl
	SDIB32GLFIXED		fxSrcAddYx_H;		// ]YxZl
	SDIB32GLFIXED		fxSrcAddYy_H;		// ]YyZl

}SDIB32GLROTATESTATUS;

typedef struct
{
	LONG		nX;			// [摜XW
	LONG		nY;			// [摜YW
	LONG		nAddDirX;	// [摜XZ
	LONG		nAddDirY;	// [摜YZ

}SDIB32GLRULESTATUS;

class CSDib32GLFactory;

/*----------------------------------------------------------------------------*
|	SDIB32GL Base Class
*----------------------------------------------------------------------------*/
class CSDib32GLBase : public ISDib32GL
{
protected:

	HDC					m_SorceDC;			// 쐬ΏۂłDC
	HBITMAP				m_hBitmap;			// rbg}bvnh
	HDC					m_hMemDC;			// DCnh
	LPSDIB32GLCOLOR		m_pBits;			// sNZobt@
	LPSDIB32GLCOLOR*	m_ppScanLine;		// sNZobt@̃XLC
	SDIB32GLCOLOR		m_ColorKey;			// ߐF
	DWORD				m_dwPixels;			// DIB̃sNZ
	DWORD				m_dwSizeImage;		// DIB̃TCY
	long				m_nWidth;			// DIB̕
	long				m_nHeight;			// DIB̍
	char				m_szFilePath[ _MAX_PATH ];	// ǂݍ݌̃t@CpX
	RECT				m_rcClip;			// ̃IuWFNg̃NbsÖ
	CSDib32GLFactory*	m_pOwnerFactory;	// I[i[t@Ng

	static	SDIB32GLCOLOR	m_MonoTbl[256];	// mNe[u

protected:

	bool Clipping( const CSDib32GLBase* lpSrc, SDIB32GLSTATUS& st, const LPSIZE lpDstSize, const LPPOINT lpSrcPt, const LPSIZE lpSrcSize );
	bool Clipping( const CSDib32GLBase* lpSrc, SDIB32GLROTATESTATUS& rst, const LPSIZE lpDstSize, const LPPOINT lpSrcPt, const LPSIZE lpSrcSize, const LPPOINT lpCenterPt );
	bool Clipping( long& nX, long& nY, long& nW, long& nH );
	void InitUniversalTransTable( DWORD* lpTransTbl, WORD wPhase, BYTE Vague );
	void InitRuleStatus( SDIB32GLRULESTATUS& rulest, SDIB32GLSTATUS& st, DWORD dwRuleFlags );
	
	/*** Common Interface's Internal Methods ***/
	INLINEMETHODIMP InternalBlt( CSDib32GLBase* lpSrcSDIB32GL, long nDstX, long nDstY, LPSIZE lpDstSize, LPPOINT lpSrcPt, LPSIZE lpSrcSize );
	INLINEMETHODIMP InternalColorKeyBlt( CSDib32GLBase* lpSrcSDIB32GL, long nDstX, long nDstY, LPSIZE lpDstSize, LPPOINT lpSrcPt, LPSIZE lpSrcSize );
	INLINEMETHODIMP InternalRotateBlt( CSDib32GLBase* lpSrcSDIB32GL, long nDstX, long nDstY, LPSIZE lpDstSize, LPPOINT lpSrcPt, LPSIZE lpSrcSize, long nAngle, LPPOINT lpCenterPt );
	INLINEMETHODIMP InternalRotateColorKeyBlt( CSDib32GLBase* lpSrcSDIB32GL, long nDstX, long nDstY, LPSIZE lpDstSize, LPPOINT lpSrcPt, LPSIZE lpSrcSize, long nAngle, LPPOINT lpCenterPt );
	INLINEMETHODIMP InternalRGBToAlphaBlt( CSDib32GLBase* lpSrcSDIB32GL, long nDstX, long nDstY, LPSIZE lpDstSize, LPPOINT lpSrcPt, LPSIZE lpSrcSize );
	INLINEMETHODIMP InternalRToAlphaBlt( CSDib32GLBase* lpSrcSDIB32GL, long nDstX, long nDstY, LPSIZE lpDstSize, LPPOINT lpSrcPt, LPSIZE lpSrcSize );
	INLINEMETHODIMP InternalGToAlphaBlt( CSDib32GLBase* lpSrcSDIB32GL, long nDstX, long nDstY, LPSIZE lpDstSize, LPPOINT lpSrcPt, LPSIZE lpSrcSize );
	INLINEMETHODIMP InternalBToAlphaBlt( CSDib32GLBase* lpSrcSDIB32GL, long nDstX, long nDstY, LPSIZE lpDstSize, LPPOINT lpSrcPt, LPSIZE lpSrcSize );
	INLINEMETHODIMP InternalAlphaToAlphaBlt( CSDib32GLBase* lpSrcSDIB32GL, long nDstX, long nDstY, LPSIZE lpDstSize, LPPOINT lpSrcPt, LPSIZE lpSrcSize );
	INLINEMETHODIMP InternalColorKeyToColorBlt( CSDib32GLBase* lpSrcSDIB32GL, long nDstX, long nDstY, LPSIZE lpDstSize, LPPOINT lpSrcPt, LPSIZE lpSrcSize, SDIB32GLCOLOR Color );

public:
	
	CSDib32GLBase() _THROW0();
	virtual ~CSDib32GLBase();

	static void InitMonoTable( void );

	HRESULT CreateBuffer( long nWidth, long nHeight, SDIB32GLCOLOR FillColor, HDC hDC );
	HRESULT LoadFromFile( const char* lpszFileName, long nOffset, const char* lpszSpiDir, SDIB32GLCOLOR ColorKey, HDC hDC );
	HRESULT LoadFromMemory( const void* pvMemory, long nSize, const char* lpszSpiDir, SDIB32GLCOLOR ColorKey, HDC hDC );
	HRESULT LoadFromResource( HINSTANCE hInstance, const char* lpszBitmapID, SDIB32GLCOLOR ColorKey, HDC hDC );
	HRESULT CopyBuffer( CSDib32GLBase* pOriginal );
	HRESULT Register( CSDib32GLFactory* pOwnerFactory );
	HRESULT Unregister( void );

	_BEGIN_COM_MAP( CSDib32GLBase )
		_COM_INTERFACE_ENTRY( ISDib32GL )
	_END_COM_MAP()

	/*** ISDib32GL methods ***/
	STDMETHODIMP SaveAsFile( const BSTR bstrFileName );
	STDMETHODIMP SaveAsFileEx( const BSTR bstrFileName, const LPSDIB32GLSAVEPICINFO lpPicInfo, LPDWORD lpdwSize );
	STDMETHODIMP Blt( ISDib32GL* lpSrcSDIB32GL, long nDstX, long nDstY, LPSIZE lpDstSize, LPPOINT lpSrcPt, LPSIZE lpSrcSize );
	STDMETHODIMP ColorKeyBlt( ISDib32GL* lpSrcSDIB32GL, long nDstX, long nDstY, LPSIZE lpDstSize, LPPOINT lpSrcPt, LPSIZE lpSrcSize );
	STDMETHODIMP RotateBlt( ISDib32GL* lpSrcSDIB32GL, long nDstX, long nDstY, LPSIZE lpDstSize, LPPOINT lpSrcPt, LPSIZE lpSrcSize, long nAngle, LPPOINT lpCenterPt );
	STDMETHODIMP RotateColorKeyBlt( ISDib32GL* lpSrcSDIB32GL, long nDstX, long nDstY, LPSIZE lpDstSize, LPPOINT lpSrcPt, LPSIZE lpSrcSize, long nAngle, LPPOINT lpCenterPt );
	STDMETHODIMP RGBToAlphaBlt( ISDib32GL* lpSrcSDIB32GL, long nDstX, long nDstY, LPSIZE lpDstSize, LPPOINT lpSrcPt, LPSIZE lpSrcSize );
	STDMETHODIMP RToAlphaBlt( ISDib32GL* lpSrcSDIB32GL, long nDstX, long nDstY, LPSIZE lpDstSize, LPPOINT lpSrcPt, LPSIZE lpSrcSize );
	STDMETHODIMP GToAlphaBlt( ISDib32GL* lpSrcSDIB32GL, long nDstX, long nDstY, LPSIZE lpDstSize, LPPOINT lpSrcPt, LPSIZE lpSrcSize );
	STDMETHODIMP BToAlphaBlt( ISDib32GL* lpSrcSDIB32GL, long nDstX, long nDstY, LPSIZE lpDstSize, LPPOINT lpSrcPt, LPSIZE lpSrcSize );
	STDMETHODIMP AlphaToAlphaBlt( ISDib32GL* lpSrcSDIB32GL, long nDstX, long nDstY, LPSIZE lpDstSize, LPPOINT lpSrcPt, LPSIZE lpSrcSize );
	STDMETHODIMP ColorKeyToColorBlt( ISDib32GL* lpSrcSDIB32GL, long nDstX, long nDstY, LPSIZE lpDstSize, LPPOINT lpSrcPt, LPSIZE lpSrcSize, SDIB32GLCOLOR Color );
	STDMETHODIMP ColorKeyToAlpha( void );
	STDMETHODIMP SetColorKey( SDIB32GLCOLOR ColorKey );
	STDMETHODIMP SetClipRect( LPRECT lpRect );
	STDMETHODIMP SetClipArea( long nX, long nY, long nW, long nH );
	STDMETHODIMP GetClipRect( LPRECT lpRect );
	STDMETHODIMP GetSize( LPSIZE lpSize );
	STDMETHODIMP GetWidth( LPDWORD lpdwWidth );
	STDMETHODIMP GetHeight( LPDWORD lpdwHeight );
	STDMETHODIMP GetDC( HDC* lphDC );
	STDMETHODIMP GetBitmap( HBITMAP* lphBitmap );
	STDMETHODIMP GetBits( LPSDIB32GLCOLOR* lplpBits );
	STDMETHODIMP GetScanLine( long nLine, LPSDIB32GLCOLOR* lplpBits );
	STDMETHODIMP GetScanLineBuffer( LPSDIB32GLCOLOR** lplplpScanLine );
	STDMETHODIMP GetColorKey( LPSDIB32GLCOLOR lpColorKey );
	STDMETHODIMP GetPixels( LPDWORD lpdwPixels );
	STDMETHODIMP GetSizeImage( LPDWORD lpdwSizeImamge );
	STDMETHODIMP GetFileName( BSTR* lpbstrFileName );
	STDMETHODIMP SetPixel( long x, long y, SDIB32GLCOLOR Color );
	STDMETHODIMP GetPixel( long x, long y, SDIB32GLCOLOR* lpColor );
	STDMETHODIMP Draw( HDC hDC );
	STDMETHODIMP Clear( SDIB32GLCOLOR Color );
	STDMETHODIMP Rectangle( long x, long y, long nWidth, long nHeight, SDIB32GLCOLOR Color );
	STDMETHODIMP Line( long x0, long y0, long x1, long y1, SDIB32GLCOLOR Color );
	STDMETHODIMP Ellipse( long x0, long y0, long rx, long ry, SDIB32GLCOLOR Color );
	STDMETHODIMP Nega( long x, long y, long nWidth, long nHeight );
	STDMETHODIMP Mosaic( long x, long y, long nWidth, long nHeight, long nBlockWidth, long nBlockHeight );
};


#endif /* _INC_SDIB32GLBASE */